/********************************************************
 ġؼ 2006 2б Homework #4
    : żа
    : 20001260
    :   
 Date : 2006.10.17
 description :   ع(Ge-Si 2 µ)
 ********************************************************/

#include <stdio.h>
#include <math.h>

#define SIZE 10

int newton1(double T, double *x1, double *y1, int n, FILE *outfile); //  ̿
void eliminate(double mat[SIZE][SIZE], double inv[SIZE][SIZE], int n); // 콺 ҰŹ
void divide(double mat[SIZE][SIZE], double inv[SIZE][SIZE], int n); // 밢  1
void addrow(double mat[SIZE][SIZE], double fact, int n, int p, int q);		//    

int main(void)
{
	int n, error;
	double x, y, xi, yi;
	double T, T1, T2, Ts, dT;
	FILE *outfile;
	
	n = 2;	//  ũ⸦ 2

	outfile = fopen("result.txt", "w");

	printf("******* Ge-Si 2 µ  α׷ *******\n\n\n");
	printf("µ  ԷϽÿ(T1 T2) : ");
	scanf("%lf%lf", &T1, &T2);
	printf("µ ġ ԷϽÿ : ");
	scanf("%lf", &dT);
	
	while(1) { // ʱ µ,        Է 
		printf(" µ ԷϽÿ : ");
		scanf("%lf", &Ts);
		printf("Si ʱ  ԷϽÿ(X1 X2) : ");
		scanf("%lf%lf", &xi, &yi);
		x = xi, y = yi;

		error = newton1(Ts, &x, &y, n, outfile);
		if (error == 1) printf("\n\n µ, Si ʱ  ٽ ԷϽÿ!\n\n\n");
		if (error == 0) {
			printf(" µǾϴ.\n");
			break;
		}
	}
	
	fprintf(outfile, "µ\t1\t\t2\t\tȸ\tȿ\n");
	
	T = Ts, x = xi, y = yi;
	while(1) { // µ Ű鼭
		newton1(T, &x, &y, n, outfile);
		if (T > T2) break;
		T = T + dT;
	}
	
	T = Ts, x = xi, y = yi;
	while(1) { // µ ҽŰ鼭
		newton1(T, &x, &y, n, outfile);
		if (T < T1) break;
		T = T - dT;
	}
	
	fclose(outfile);
}

int newton1(double T, double *x1, double *y1, int n, FILE *outfile)
{
	int i, j, count = 0;
	char error = 'O';
	double mat[SIZE][SIZE], inv[SIZE][SIZE];// matrix, inverse matrix
	double x0, y0, F1, F2;
	
	x0 = *x1, y0 = *y1; //  µ  ʱ  
	
	while(1) {
		mat[0][0] = (8.3144 * T) / x0; // Jacobian matrix 
		mat[0][1] = -(8.3144 * T) / y0;
		mat[1][0] = (8.3144 * T) / (x0 - 1);
		mat[1][1] = (8.3144 * T) / (1 - y0);

		for (i=0; i < n; i++) {			// ׵ Ŀ 
			for (j=0; j < n; j++) {
				inv[i][j] = 0;
			}
			inv[i][i] = 1;
		}

		eliminate(mat,inv,n);			// 콺 ҰŹ   ȯ ǽϴ Լ
		divide(mat,inv,n);				//  밢  1 ȯϴ Լ

		if (x0 < 0 || x0 > 1 || y0 < 0 || y0 > 1) { //  ó
			error = 'X';
			break;
		}
		F1 = 50208.00 - 29.7617 * T + 8.3144 * T * log(x0/y0);
		F2 = 36944.72 - 30.4975 * T + 8.3144 * T * log((1-x0)/(1-y0));
		
		*x1 = x0 - (inv[0][0] * F1 + inv[0][1] * F2);
		*y1 = y0 - (inv[1][0] * F1 + inv[1][1] * F2);
		
		if (count > 30) break; //  ó
		if (fabs(*x1-x0) < 0.000001 && fabs(*y1-y0) < 0.000001) break;
		
		x0 = *x1, y0 = *y1;
		count++;
	}
	fprintf(outfile, "%.1lf\t%.6lf\t%.6lf\t%d\t%c\n", T, x0, y0, count, error);
	if (error == 'X') return 1;
	else return 0;
}

void eliminate(double mat[SIZE][SIZE], double inv[SIZE][SIZE], int n) // 콺 ҰŹ
{
	int i, j;
	double fact;

	for (i=0; i < n-1; i++) {		//  밢 ϴ 0
		for (j=i+1; j < n; j++) {
			fact = mat[j][i] / mat[i][i];
			addrow(mat, fact, n, i, j);
			addrow(inv, fact, n, i, j);
		}
	}

	for (i=n-1; i > 0; i--) {		//  밢  0
		for (j=i-1; j >= 0; j--) {
			fact = mat[j][i] / mat[i][i];
			addrow(mat, fact, n, i, j);
			addrow(inv, fact, n, i, j);
		}
	}
}

void divide(double mat[SIZE][SIZE], double inv[SIZE][SIZE], int n) // 밢  1
{
	int i, j;
	double fact;
	for (i=0; i < n; i++) {
		fact = 1 / mat[i][i];
		for (j=0; j < n; j++) {
			mat[i][j] = mat[i][j] * fact;
			inv[i][j] = inv[i][j] * fact;
		}
	}
}

void addrow(double mat[SIZE][SIZE], double fact, int n, int p, int q)	//    
{
	int i;
	for (i=0; i < n; i++) {
		mat[q][i] = mat[q][i] - mat[p][i] * fact;
	}
}
